//==============================================================
// IR wave recoder Ver0.71    (STPP.03)
//     for PSP CFW3.80 M33-5 + 1.50 Kernel addon (PSP-1000p)
// STEAR 2008
//--------------------------------------------------------------
// IR wave viewer̔hAvŁAԊOMMđL^肷
// @\t́B
// wK^R̃TvIȂ̂łB
// IrDÃ{[[gύX邽߃n[h𒼐ڂĂ̂ŃJ[l[h
// œĂ܂B

#include <pspkernel.h>
#include <psppower.h>
#include <pspgu.h>
#include <pspdisplay.h>
#include <pspctrl.h>
#include <pspsystimer.h>
#include "psposk.h"
#include <psputility.h>
#include <string.h>

#include "zenkaku.h"
#include "serialport.h"
#include "rawir.h"

//----- }N -----

#define SCRBUF0		(char*)(0)

/*LbVȂVRAM  VRAM[y][x]ƂăANZX*/
#define VRAM		((long(*)[BUF_WIDTH])(((char*)0x4000000)+0x40000000))

//----- 萔ݒ -----

#define IRBUFSIZE	5*40000										// IRMobt@TCY (5bԕ)
#define CORLINE		0x80C080									// r
#define CORTITLE	0x507050									// ^Cgwi
#define CORROLLBAR	0x90FF90									// XN[o[
#define CORLOW		0x204000									// LOW
#define CORHI		0x8080FF									// HI
#define CORREC		0x906090									// M
#define CORERR		0x4040A0									// G[_CAO
#define CORSELECT	0x704040									// I_CAO
#define CORKEY		0xA0A0A0									// _CAO

#define RAWSIZE		300											// L^łg`̍ő
#define IRFILE		"IRWAVE.DAT"								// ۑ鎞̃t@C

//----- vg^Cv錾 -----

//- VXe֘A -

int		SetupCallbacks(void);
int		callbackThread(SceSize args, void *argp);
int		exitCallback(int arg1, int arg2, void *common);
int		power_callback(int unknown, int pwrflags, void *common);

//- ̑ -

void	ScrDraw(void);
void	BtnRec(void);
void	IrSend(int btn);
void	InputName(int btn);
int		IrRec(int btn);
void	WaveDraw(long DrawPos,int Range);
void	RollBar(long pos,int range);
void	RangeDraw(int range);
void	PacketDraw(int range);
void	WaveLog(void);
void	HLine(int x,int y,int wx,long cor);
void	VLine(int x,int y,int wy,long cor);
void	Box(int x,int y,int wx,int wy,long corFrame);
void	BoxFill(int x,int y,int wx,int wy,long corFrame,long corIn);
void	BoxClr(int x,int y,int xw,int yw);
void	ValDraw3(int x,int y,int va);
void	SetIrBPS(void);
int		timer_handler(void);

//------ O[oϐ -----

static volatile unsigned char gIrWave[IRBUFSIZE];				// IRMobt@(Oobt@)
static unsigned int __attribute__((aligned(16))) gList[262144];
static volatile int	gExitRequest = 0,
					gResumeFlag = 0,
					gBlankTime = 400,							// t[Ԋu
					gIrStartFlag;								// L^Jn^C~Op
static volatile long gIWPosT,gIWSize;							// IRMobt@̃|C^
static volatile long gAnchor1 = 0,gAnchor2 = 0;					// AJ[|Cg
SceSysTimerId gTimer;

struct {
	int		len;												// g`f[^̃TCY (0:f[^)
	int		frq;												// gg
	u32		raw_buffer[RAWSIZE];								// g`f[^
	char	name[33];											// {^
} gRaw[10];														// e{^ɓo^ꂽg`f[^

//------ s[hw -----

PSP_MODULE_INFO("IRRecorder", 0x1000, 1, 1);					// J[l[h
PSP_MAIN_THREAD_ATTR(0);
PSP_MAIN_THREAD_STACK_SIZE_KB(32);								// ꂪƃTXyhoȂH


//==============================================================
// main
//--------------------------------------------------------------

int	main(int argc,char **argv)
{
	SceCtrlData	pad;
	int			fd,ret;

	SetupCallbacks();

	sceGuInit();
	sceGuStart(GU_DIRECT, gList);
	sceGuDrawBuffer(GU_PSM_8888, SCRBUF0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, SCRBUF0, BUF_WIDTH);
	sceGuFinish();
	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_DIGITAL);

	fd = sceIoOpen(IRFILE, PSP_O_RDONLY, 0777);					// f[^ǂݍ
	if (fd >= 0){
		ret = sceIoRead(fd, gRaw, sizeof(gRaw));
		sceIoClose(fd);
		if (ret != sizeof(gRaw))								// TCYȂNA
			memset(gRaw, 0, sizeof(gRaw));
	}

	ScrDraw();													// ʍ\z

	while(!gExitRequest){
		sceCtrlReadBufferPositive(&pad, 1);
		if (pad.Buttons & PSP_CTRL_UP){
			IrSend(0);
		}
		if (pad.Buttons & PSP_CTRL_DOWN){
			IrSend(1);
		}
		if (pad.Buttons & PSP_CTRL_LEFT){
			IrSend(2);
		}
		if (pad.Buttons & PSP_CTRL_RIGHT){
			IrSend(3);
		}
		if (pad.Buttons & PSP_CTRL_TRIANGLE){
			IrSend(4);
		}
		if (pad.Buttons & PSP_CTRL_CROSS){
			IrSend(5);
		}
		if (pad.Buttons & PSP_CTRL_SQUARE){
			IrSend(6);
		}
		if (pad.Buttons & PSP_CTRL_CIRCLE){
			IrSend(7);
		}
		if (pad.Buttons & PSP_CTRL_LTRIGGER){
			IrSend(8);
		}
		if (pad.Buttons & PSP_CTRL_RTRIGGER){
			IrSend(9);
		}

		if (pad.Buttons & PSP_CTRL_START){						// L^[h
			BtnRec();
			ScrDraw();											// {^̓o^󋵂XV
		}
		sceDisplayWaitVblankStart();
	}
	sceGuTerm();
	sceKernelExitGame();
	sceKernelSleepThread();
	return 0;
}


//==============================================================
// ʂ̍\z
//--------------------------------------------------------------

void ScrDraw(void)
{
	const char	btStr[10][5] = {"F","F","F","F","F","~F","F","F","kF","qF"};
	int			i,y;

	mh_print(  0, FONTHEIGHT*0, "IR wave recorder Ver0.71", 0xFFFFFF);
	mh_print(220, FONTHEIGHT*0, "[START]FIR Record", 0x707070);
	mh_print(400, FONTHEIGHT*0, "(c)STEAR 2008", 0x707070);

	for (i=0; i<10 ;i++){										// o^f[^̕\
		y = 20 + i * FONTHEIGHT;
		BoxClr( 0, y, SCR_WIDTH,FONTHEIGHT);					// s
		mh_print(  6, y, btStr[i], 0xFFFFFF);
		if (gRaw[i].len == 0)
			mh_print( 30, y, "No DATA", 0x40C0C0);
		else
			mh_print( 30, y, gRaw[i].name, 0xFFFFFF);
	}
}

//==============================================================
// {^Sė܂őҋ@
//--------------------------------------------------------------

void popKey(void)
{
	SceCtrlData	pad;

	while (1){
		sceCtrlReadBufferPositive(&pad, 1);
		if (!(pad.Buttons & 0x0FFFF))
			break;
		sceDisplayWaitVblankStart();
	}
}

//==============================================================
// ԊOM̓o^
//--------------------------------------------------------------
// ̂ƐԊOM̎荞݂s܂B
// 擾f[^͂̂ǃ[XeBbNɋL^܂B
// L^f[^鎖͍lĂ܂B

void BtnRec(void)
{
	int			btn,fd;
	SceCtrlData	pad;

	BoxFill(140,80,200,46,CORLINE,CORTITLE);					// bZ[W_CAO
	mh_print(150,90,"L^{^Ă", 0xFFFFFF);
	mh_print(195,104,"CANCELF[START]", CORKEY);

	popKey();													// {^܂őҋ@

	btn = -1;
	while (!gExitRequest && btn == -1){							// {^܂őҋ@
		sceCtrlReadBufferPositive(&pad, 1);
		if (pad.Buttons & PSP_CTRL_UP){
			btn = 0;
		}
		if (pad.Buttons & PSP_CTRL_DOWN){
			btn = 1;
		}
		if (pad.Buttons & PSP_CTRL_LEFT){
			btn = 2;
		}
		if (pad.Buttons & PSP_CTRL_RIGHT){
			btn = 3;
		}
		if (pad.Buttons & PSP_CTRL_TRIANGLE){
			btn = 4;
		}
		if (pad.Buttons & PSP_CTRL_CROSS){
			btn = 5;
		}
		if (pad.Buttons & PSP_CTRL_SQUARE){
			btn = 6;
		}
		if (pad.Buttons & PSP_CTRL_CIRCLE){
			btn = 7;
		}
		if (pad.Buttons & PSP_CTRL_LTRIGGER){
			btn = 8;
		}
		if (pad.Buttons & PSP_CTRL_RTRIGGER){
			btn = 9;
		}

		if (pad.Buttons & PSP_CTRL_START){						// LZ
			btn = -2;
		}
		sceDisplayWaitVblankStart();
	}
	if (btn < 0 || gExitRequest){
		popKey();												// {^܂őҋ@
		return;													// LZꂽ
	}

	if (!IrRec(btn)){											// Mg`L^
//		InputName(btn);											// M̓
		memcpy(gRaw[btn].name,"Entry",6);						// 肠c
		fd = sceIoOpen(IRFILE, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777);
		if (fd >= 0){											// f[^ۑ
			sceIoWrite(fd, gRaw, sizeof(gRaw));
			sceIoClose(fd);
		} else {
			BoxFill(140,80,200,46,CORLINE,CORERR);				// bZ[W_CAO
			mh_print(150,90,"t@Cւ̕ۑɎs܂", 0xFFFFFF);
			mh_print(222,104,"OKF", CORKEY);
			popKey();											// {^܂őҋ@
			while(!gExitRequest){
				sceCtrlReadBufferPositive(&pad, 1);
				if (pad.Buttons & PSP_CTRL_CIRCLE)
					break;
				sceDisplayWaitVblankStart();
			}
		}
	}
	popKey();													// {^܂őҋ@
	BoxClr(0,0,SCR_WIDTH,SCR_HEIGHT);							// ʃNA
}

//==============================================================
// M̓
//--------------------------------------------------------------
// OSKɂ閼̓͂łB
// cAȂ񂩃nOcBJ[l[hH

void InputName(int btn)
{
	unsigned short intext[128]  = { 0 }; 						// text already in the edit box on start
	unsigned short outtext[128] = { 0 }; 						// text after input
	unsigned short desc[128]    = { 'D', 'A', 'T', 'A' , ' ', 'N', 'a', 'm', 'e', 0 }; // description
	int	i,done = 0;

//	for (i=0; i<32 ;i++)										// ftHgݒ
//		intext[i] = gRaw[btn].name[i];
//	intext[32] = 0;

	PspOskData data;
	memset(&data, 0, sizeof(data));
	data.unk_00 = 1;
	data.unk_04 = 0;
	data.language = 0;											// hiragana
	data.unk_12 = 0;
	data.unk_16 = 0;
	data.lines = 1;												// just online
	data.unk_24 = 1;											// set to 1
	data.desc = desc;
	data.intext = intext;
	data.outtextlength = 128;									// sizeof(outtext) / sizeof(unsigned short)
	data.outtextlimit = 32;										// just allow 32 chars
	data.outtext = outtext;

	PspOsk osk;
	memset(&osk, 0, sizeof(osk));
	osk.size = sizeof(osk);
	osk.language = 0;
	osk.buttonswap = 0;
	osk.unk_12 = 17;											// What
	osk.unk_16 = 19;											// the
	osk.unk_20 = 18;											// fuck
	osk.unk_24 = 16;											// ???
	osk.unk_48 = 1;
	osk.data = &data;

	if (sceUtilityOskInitStart(&osk)){
		return;
	}

	while (!done){
		sceGuStart(GU_DIRECT,gList);
		sceGuClearColor(0x666666);
		sceGuClearDepth(0);
		sceGuClear(GU_COLOR_BUFFER_BIT | GU_DEPTH_BUFFER_BIT);

		sceGuFinish();
		sceGuSync(0,0);

		switch (sceUtilityOskGetStatus()){
		case OSK_NONE:
			break;
		case OSK_INIT:
			break;
		case OSK_VISIBLE:
			sceUtilityOskUpdate(2); // 2 is taken from ps2dev.org recommendation
			break;
		case OSK_QUIT:
			sceUtilityOskShutdownStart();
			break;
		case OSK_FINISHED:
			done = 1;
			break;
		default:
			break;
		}

		sceDisplayWaitVblankStart();
		sceGuSwapBuffers();
	}

	for (i=0; i<32 ;i++)										// ͂ꂽ̎荞
		gRaw[btn].name[i] = outtext[i];
}


//==============================================================
// ԊOM̎荞
//--------------------------------------------------------------
// IR wave viewerقڂ̂܂܁B
// Ōɔg`f[^̉͂ǉB
//
// ߂lF0:o^ -1:LZꂽ

//----- vg^Cv -----

int	IrRecSet(int btn,int log1,long count,int rPos);

//----- C -----

int IrRec(int btn)
{
	unsigned char	data[20];
	int				x,fd,range,padPush,mode,log1,log2,rPos;
	long			i,pos,sum,count;
	SceCtrlData		pad;

	//----- ʍ\z -----

	BoxClr(0,0,SCR_WIDTH,SCR_HEIGHT);							// ʃNA

	mh_print(  0, FONTHEIGHT*0, "ԊOf[^M", 0x8080FF);
	mh_print(130, FONTHEIGHT*0, ":PAUSE :F.BLANK :Record ~:CANCEL :ݼޕύX", 0x707070);

	BoxFill(0,15,70,16,CORLINE,CORTITLE);						// Mf[^
	BoxFill(0,30,SCR_WIDTH,9,CORLINE,0x000000);					// Mf[^XN[o[
	VLine(  0, 37,33,CORLINE);									// Mf[^
	VLine(479, 37,33,CORLINE);									// Mf[^
	BoxFill(0,89,70,16,CORLINE,CORTITLE);						// t[^Cg
	BoxFill(0,104,SCR_WIDTH,15,CORLINE,0x000000);				// t[
	BoxFill(0,122,70,16,CORLINE,CORTITLE);						// O^Cg
	BoxFill(0,137,SCR_WIDTH,135,CORLINE,CORLOW);				// O

	mh_print(  3, 17, "Mf[^", 0xFFFFFF);
	mh_print( 90, 17, "W:", 0xFFFFFF);
	mh_print(170, 17, "MW:", 0xFFFFFF);
	mh_print(  3, 91, "t[", 0xFFFFFF);
	mh_print( 90, 91, "t[Ԋu:000ms", 0xFFFFFF);
	ValDraw3( 90+ FONTWIDTH*13, 91, gBlankTime/40);				// t[Ԋu\
	mh_print(  3, 124, "Log", 0xFFFFFF);
	RangeDraw(0);												// Wƃ[[̕\̓ϐZbg
	range = 1;
	RangeDraw(range);											// Wƃ[[̕\

	//----- ݒ -----

	gAnchor1 = 0;
	gAnchor2 = 0;
	memset(gIrWave, 0, IRBUFSIZE);								// Mobt@NA
	gIrStartFlag = 0;											// 0ȂIRHI͂܂ŃTvOsȂ
	gIWPosT = 0;												// IrWave擪ʒu
	gIWSize = 0;												// IrWaveTCY

	fd = sceIoOpen("irda0:", PSP_O_RDWR, 0);					// IrDAI[v
	SetIrBPS();													// BPS1500000֕ύX
	serialport_read(&psprc_serialport, data, 20,1);				// IR FIFONA
	gTimer = sceSTimerAlloc();
	sceSTimerStartCount(gTimer);
	sceSTimerSetHandler(gTimer, 4194303/4000, timer_handler, 0);	//0.025[ms]PʂIRTvO

	//----- C -----

	popKey();													// {^܂őҋ@

	mode = 0;													// 0:M 1:g`\
	padPush = 0;												// z^Ă邩 0:No 1:Yes
	pos = 0;													// Mf[^\ʒu
	while(!gExitRequest){
		if (gResumeFlag){										// W[ꂽ
			gResumeFlag = 0;
			SetIrBPS();											// BPS1500000֕ύX
		}
		sceCtrlReadBufferPositive(&pad, 1);
		if (pad.Buttons & PSP_CTRL_SQUARE){						// 荞݊
			break;
		}
		if (pad.Buttons & PSP_CTRL_CROSS){						// LZ
			mode = -1;
			break;
		}
		if (pad.Buttons & PSP_CTRL_TRIANGLE && padPush == 0){
			gBlankTime += 40;									// t[ԊuԐ؂ւ
			if (gBlankTime > 800) gBlankTime = 40;
			ValDraw3(90+ FONTWIDTH *13, 91, gBlankTime/40);		// t[Ԋu\
			if (mode) PacketDraw(range);						// t[̓\
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_CIRCLE && padPush == 0){		// [hύX
			if (mode){
				BoxClr(0,0,FONTWIDTH*18,FONTHEIGHT);
				mh_print(0, FONTHEIGHT*0,"ԊOf[^M", CORHI);
				BoxClr(170+ FONTWIDTH*9, 17, FONTWIDTH *3, FONTHEIGHT);
				sceSTimerStartCount(gTimer);					// IRTvOJn
				mode = 0;
				padPush = 1;
				pos = 0;
			} else {
				BoxClr(0, 0, FONTWIDTH *18, FONTHEIGHT);
				mh_print(0, FONTHEIGHT*0, "g`\\", 0xFF8080);
				sceSTimerStopCount(gTimer);						// IRTvO~
				mode = 1;
				padPush = 1;
				pos = 0;
				sum = 0;
				count = 1;
				for (i=0; i<IRBUFSIZE ;i++)						// MW̏Wv
					if (gIrWave[i] != 0){
						sum += gIrWave[i];
						count++;
					}
				sum = sum * 100 / count;
				ValDraw3(170+ FONTWIDTH *9, 17, sum);
			}
		}
		if (pad.Buttons & PSP_CTRL_UP && padPush == 0){
			range++;
			if (range > 99) range = 99;
			PacketDraw(range);									// t[̓\
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_DOWN && padPush == 0){
			range--;
			if (range < 1) range = 1;
			PacketDraw(range);									// t[̓\
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_LEFT){
			pos += 1 * range;
			if (pos > gIWSize) pos = gIWSize;
		}
		if (pad.Buttons & PSP_CTRL_RIGHT){
			pos -= 1 * range;
			if (pos < 0) pos = 0;
		}
		if (pad.Buttons & PSP_CTRL_LTRIGGER && padPush == 0){
			pos += 350 * range;
			if (pos > gIWSize) pos = gIWSize;
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_RTRIGGER && padPush == 0){
			pos -= 350 * range;
			if (pos < 0) pos = 0;
			padPush = 1;
		}
		if (!(pad.Buttons & 0x0FFF0))							// {^ĂȂ
			padPush = 0;

		RollBar(pos, range);									// XN[o[
		RangeDraw(range);										// Wƃ[[̕\
		WaveDraw(pos, range);									// ԊOg`
		if (!mode){
			PacketDraw(range);									// t[̓\
			WaveLog();											// Mf[^O
		}
		sceDisplayWaitVblankStart();
	}
	sceSTimerFree(gTimer);
	sceIoClose(fd);
	if (gExitRequest || mode == -1) return -1;					// LZꂽ

	//----- gI -----

	BoxFill(140,80,200,64,CORLINE,CORSELECT);					// bZ[W_CAO
	mh_print(156, 90,"ggIł", 0xFFFFFF);
	mh_print(189,104,":I ~:CANCEL", CORKEY);
	mh_print(174,122,"36kHz 38kHz 40kHz 42kHz", 0xFFFFFF);
	x = 2;
	Box(172 + x * 36,121,34,13,CORLINE);
	popKey();													// {^܂őҋ@
	padPush = 0;
	while (!gExitRequest){
		sceCtrlReadBufferPositive(&pad, 1);
		if (pad.Buttons & PSP_CTRL_LEFT && padPush == 0){
			Box(172 + x * 36,121,34,13,CORSELECT);
			x--;
			if (x < 0) x = 0;
			Box(172 + x * 36,121,34,13,CORLINE);
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_RIGHT && padPush == 0){
			Box(172 + x * 36,121,34,13,CORSELECT);
			x++;
			if (x > 3) x = 3;
			Box(172 + x * 36,121,34,13,CORLINE);
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_CIRCLE){						// 
			break;
		}
		if (pad.Buttons & PSP_CTRL_CROSS){						// LZ
			x = -1;
			break;
		}
		if (!(pad.Buttons & 0x0FFF0))							// {^ĂȂ
			padPush = 0;
		sceDisplayWaitVblankStart();
	}
	if (gExitRequest || x == -1) return -1;						// LZꂽ
	gRaw[btn].frq = 36 + x * 2;									// gg

	//----- f[^ -----

	if (gAnchor1 == gAnchor2) return -1;						// t[擾ĂȂ
	pos = gAnchor1;
	log1 = 1;													// ŏ͕KHI
	count = 0;													// g (TvOƑMtick܂ܓ̂ŊZ͂ĂȂ)
	for (rPos = 0; rPos < 9 ;rPos++)							// _~[f[^ (8ԖڂŖȃEFCgcsircstH[}bg̗݂H)
		gRaw[btn].raw_buffer[rPos] = IR_SIGNAL_OFF(1);
	while (pos != gAnchor2){
		count++;
		pos++;
		if (pos >= IRBUFSIZE) pos -= IRBUFSIZE;
		log2 = (gIrWave[pos]) ? 1 : 0;
		if (log1 != log2){										// ω_
			rPos = IrRecSet(btn, log1, count, rPos);			// gf[^
			count = 0;
			log1 = log2;
		}
		if (rPos >= RAWSIZE) break;								// obt@Ȃ̂Œf
	}
	rPos = IrRecSet(btn, log1, count, rPos);					// gf[^
	gRaw[btn].len = rPos;
	return 0;													// o^
}

//--------------------------------------------------------------
// Mobt@ɔgf[^Zbg
//--------------------------------------------------------------
// 0.025[ms]Pʂ̔gf[^SendRawIR()ň`ɕϊăobt@Ɋi[B

int IrRecSet(int btn,int HiLow,long count,int rPos)
{
	while (1){													// 255Pʂŕ
		if (count < 256){
			gRaw[btn].raw_buffer[rPos++] = (HiLow) ? IR_SIGNAL_ON(count) : IR_SIGNAL_OFF(count);
			break;
		} else {
			gRaw[btn].raw_buffer[rPos++] = (HiLow) ? IR_SIGNAL_ON(255) : IR_SIGNAL_OFF(255);
			count -= 255;
		}
		if (rPos >= RAWSIZE) break;								// obt@Ȃ
	}
	return (rPos);
}

//==============================================================
// ԊOM̑M
//--------------------------------------------------------------
// w肳ꂽԍ̐ԊOM𑗐MB
// w肳ꂽԍ̃f[^ꍇ͉ȂB
// gςƔɑM̐M̒ςĂ܂܂A덷͈̔
// ĂƂŕ␳͂Ă܂B

void IrSend(int btn)
{
	RAW_IR_DATA	irdata;

	if (gRaw[btn].len == 0) return;								// f[^o^ĂȂ

	irdata.timing_val = gRaw[btn].frq / 2;						// ggݒ
	irdata.raw_buffer = gRaw[btn].raw_buffer;					// 40kHz1tick0.025[ms]
	irdata.raw_count = gRaw[btn].len;
	SendRawIR(&irdata, 1);										// ԊOf[^M
}

//==============================================================
// ԊOg`̍
//--------------------------------------------------------------

void WaveDraw(long DrawPos,int Range)
{
	long pos,poss,len,cor;
	int i,x,sum,cnt;

	pos = gIWPosT - 1;
	len = gIWSize;
	if (DrawPos > len) DrawPos = len;
	pos -= DrawPos;
	if (pos < 0) pos += IRBUFSIZE;
	len -= DrawPos;
	x = SCR_WIDTH -1;
	while(x>1){
		if (len <= 0){
			BoxClr(1,40,x-1,30);								// ]vȃS~͏
			break;
		}
		sum = 0;
		cnt = 0;
		poss = pos;
		for (i=0; i<Range ;i++){								// Range͈̔͂̃f[^̕ς𒲂ׂ
			sum += gIrWave[poss];
			if (gIrWave[poss]) cnt++;
			poss--;
			if (poss < 0) poss += IRBUFSIZE;
		}
		if (cnt)
			sum = (sum+cnt-1) / cnt;							// _ȉ؂グ
		else
			sum = 0;
		for (i=0; i<16 ;i++)									// M
			VRAM[55-i][x-1] = (sum==0 || i>sum*3) ? CORLOW : CORREC;
		cor = (sum==0) ? CORLOW : CORHI;
		for (i=0; i<13 ;i++)									// Mg`
			VRAM[57+i][x-1] = cor;
		pos -= Range;
		if (pos < 0) pos += IRBUFSIZE;
		len -= Range;
		x--;
	}
}

//==============================================================
// XN[o[̕\
//--------------------------------------------------------------

void RollBar(long pos,int range)
{
	int i;
	long len,p;
	static long lenBuf = 0,pBuf = 0;

	if (gIWSize == 0)
		p = 0;
	else
		p = pos * (SCR_WIDTH -2) / gIWSize;
	if (gIWSize == 0)
		len = SCR_WIDTH -2;
	else
		len = (SCR_WIDTH -1) * SCR_WIDTH * range / gIWSize;
	if (len > (SCR_WIDTH -2)) len = SCR_WIDTH -2;				// ʂ͂ݏoꍇ̕␳
	if (p + len > (SCR_WIDTH -2)) p = SCR_WIDTH -2 - len;		// ʂ͂ݏoꍇ̕␳

	if (lenBuf == len && pBuf == p) return;						// OƓȂ悵Ȃ
	lenBuf = len;
	pBuf = p;

	for (i=0; i<7 ;i++){										// XN[o[
		HLine(1,31+i,SCR_WIDTH-2,CORTITLE);						// x
		HLine(SCR_WIDTH-1 -p -len,31+i,len,CORROLLBAR);			// V㏑
	}
}

//==============================================================
// W̕\ƃXP[̕\
//--------------------------------------------------------------

void RangeDraw(int range)
{
	static int bak = 0;
	int a,i,x;

	if (bak == range) return;									// Kv̖Ƃ͏Ȃ
	bak = range;
	if (range == 0) return;										// W͈͊O

	ValDraw3(90+FONTWIDTH*7,17,range);							// W

	BoxClr(0,70,480,FONTHEIGHT+3);
	for (i=0; i<SCR_WIDTH ;i++){								// ڈ
		VRAM[70][i] = CORLINE;
		if (i %  4 == 0) VRAM[70 +1][i] = 0xFFFFFF;
		if (i % 20 == 8) VRAM[70 +2][i] = 0xFFFFFF;
		if (i % 40 == 8) VRAM[70 +3][i] = 0xFFFFFF;
	}
	x = 8;
	a = 0;
	while(x<SCR_WIDTH){											// XP[̒l
		ValDraw3(x-8,70 +5,a);
		x += 40;
		a += range;
	}
	mh_print(465,70 + 5,"ms", 0xFFFFFF);
}

//==============================================================
// t[̓\
//--------------------------------------------------------------
// t[̓́uԊO͂̃TvOvłĂ܂B
// obt@̃f[^ɍ悵Ă邽߁Aobt@NAƕ\
// ܂B

void PacketDraw(int range)
{
	int  x;
	long pos,len;

	if (gAnchor1 > gAnchor2)
		len = (gAnchor2 + IRBUFSIZE) - gAnchor1;
	else
		len = gAnchor2 - gAnchor1;
	len = len / range + 1;										// \t[̃TCY

	pos = gAnchor1;
	for (x=1; x<SCR_WIDTH-1 ;x++){
		if ((x-1) <= len)										// t[
			VLine(x, 105, 13, (gIrWave[pos] == 0) ? CORLOW : CORHI);
		else													// t[O
			VLine(x, 105, 13, 0);
		pos += range;
		if (pos >= IRBUFSIZE) pos -= IRBUFSIZE;
	}
}

//==============================================================
// Mf[^̃TlC
//--------------------------------------------------------------
// Mobt@̓e1/3ɏkĉʂɕ\Ă܂B
// ԕׂ鏈B

void WaveLog(void)
{
	const long cor[] = {CORLOW,0x3030B0,0x7070E0,0x9090FF,0xB0B0FF,0xE0E0FF};
	      long i,j,pos;

	pos = gIWPosT;
	for (i=SCR_HEIGHT-1; i>138 ;i--)
		for (j=SCR_WIDTH-1; j>1 ;j--){
			VRAM[i-1][j-1] = cor[gIrWave[pos]];
			pos -=3;
			if (pos < 0) pos += IRBUFSIZE;
		}
}

//==============================================================
// ̍
//--------------------------------------------------------------

void HLine(int x,int y,int wx,long cor)
{
	int i;

	for (i=0; i<wx ;i++)
		VRAM[y][x+i] = cor;
}

//==============================================================
// c̍
//--------------------------------------------------------------

void VLine(int x,int y,int wy,long cor)
{
	int i;

	for (i=0; i<wy ;i++)
		VRAM[y+i][x] = cor;
}

//==============================================================
// BOX̍
//--------------------------------------------------------------

void Box(int x,int y,int wx,int wy,long corFrame)
{
	HLine(x       ,y       ,wx,corFrame);
	VLine(x       ,y       ,wy,corFrame);
	VLine(x + wx-1,y       ,wy,corFrame);
	HLine(x       ,y + wy-1,wx,corFrame);
}

//==============================================================
// hԂꂽBOX̍
//--------------------------------------------------------------

void BoxFill(int x,int y,int wx,int wy,long corFrame,long corIn)
{
	int	i;

	for (i=0; i<wy ;i++)										// ghԂ
		HLine(x,y + i,wx,corIn);
	Box(x,y,wx,wy,corFrame);
}

//==============================================================
// ẅ̃NA
//--------------------------------------------------------------

void BoxClr(int x,int y,int wx,int wy)
{
	int i;

	for (i=0; i<wy ;i++)
		HLine(x,y + i,wx,0);
}

//==============================================================
// wʒuɐl`(3)
//--------------------------------------------------------------
// 3ȏ̐lw肳ꂽꍇ͉3\܂B
// wi͏܂B
// ȈՓIȎłB

void ValDraw3(int x,int y,int va)
{
	char s[4];

	s[0] = '0' + ((va / 100) % 10);
	s[1] = '0' + ((va /  10) % 10);
	s[2] = '0' + ((va /   1) % 10);
	s[3] = 0;
	BoxClr(x,y,FONTWIDTH*3,FONTHEIGHT);
	mh_print(x,y, s, 0xFFFFFF);
}

//==============================================================
// ԊO͂̃TvO
//--------------------------------------------------------------
// 0.025[ms]IrDA|[gǂ݁Af[^ΐԊOHÍAf[^
// LOW͂ƔfAʂgIrWave[]ɋL^܂B
// ̃TvOƒIHI͂r؂Ă܂̂ŕԏ
// ܂B
// gIrWave[]̓e
//     0 : LOW
//     1 : ԂꂽHI
//     2 : HI (M1)
//     3 : HI (M2)
//     4 : HI (M3)
//     5 : HI (M4ȏ)
// ԂHI͎̕ώM𒲂ׂΐԊOgg𐄑łƎvǁA
// ǂ낤H
// ŐṼf[^gIWPosT-1̈ʒuɂAɌgIWSizef[^
// ܂B(0Ȃf[^)
// Oobt@Ȃ̂gIWSizeIRBUFSIZEɒBĂ܂ƈԌÂ
// f[^㏑Ă܂B
//
// gIrStartFlag0̎LOWf[^͓ǂݔ΂܂B܂HI͑҂ԂłB
//
// 莞Ԉȏ̖MԂĂHI͂AMt[
// JnʒuƔfAJ[ݒuĂ܂B
// ÕAJ[ʒu獡̃AJ[ʒu܂łMt[PɂȂł
// At[̕ԂK؂ɐݒ肵ȂƂƃt[ołȂ̂
// ӂKvBit[̋󔒎Ԃ͒At[ԊԊu͒Zj

int	timer_handler(void)
{
	static unsigned char	data[20];
	static int				len,buf[3];
	static long				pos,ancCnt = 0,ancBuf;

	len = serialport_read(&psprc_serialport, data, 20,1);
	if (len) gIrStartFlag = 1;									// HI͂L^Jn
	if (gIrStartFlag){
		if (len>5) len = 5;
		buf[0] = buf[1];
		buf[1] = buf[2];
		buf[2] = len;
		if (len) len++;
		if (buf[0]!=0 && buf[1]==0 && buf[2]!=0 && gIWSize>2){	// HI͕ (HI,LOW,HI̕тɂȂLOWHIɒu)
			pos = gIWPosT - 1;
			if (pos < 0) pos += IRBUFSIZE;						// Oobt@̋E
			gIrWave[pos] = 1;
		}
		gIrWave[gIWPosT] = len;

		pos = gIWPosT - 1;										// t[̊Jnʒu
		if (pos < 0) pos += IRBUFSIZE;
		if (gIrWave[gIWPosT] != 0){
			if (gIrWave[pos] == 0){								// LOWHI
				if (ancCnt >= gBlankTime){						// LOW莞Ԉȏ㑱Ă
					ancBuf = gIWPosT;							// t[Jnʒu
				}
				ancCnt = 0;
			}
		} else {
			ancCnt++;											// LOW̎ԂJEg
			if (ancCnt == gBlankTime){							// LOW莞ԑ
				gAnchor1 = ancBuf;
				gAnchor2 = gIWPosT;								// t[IʒuɃAJ[Zbg
				if (gAnchor2 < 0) gAnchor2 += IRBUFSIZE;
			}
		}

		gIWPosT++;
		if (gIWPosT >= IRBUFSIZE) gIWPosT -= IRBUFSIZE;
		gIWSize++;
		if (gIWSize >= IRBUFSIZE) gIWSize = IRBUFSIZE;
	}
	return -1;
}

//==============================================================
// IrDA|[gBPSύX
//--------------------------------------------------------------
// IrDA|[g͂OPEN9600bpsɐݒ肳Ă̂Aꂾ
// \SȂ̂Ő퓮삷͈͓ŎvグĂ܂B
// XԊORIrDA̕ϒɂ͌݊̂IrDA̋KiȂĖ
// łB

void SetIrBPS(void)
{
	serialport_setspeed(&psprc_serialport,1500000);				// BPS1500000֕ύX
}

//==============================================================
// Exit callback
//--------------------------------------------------------------

int exit_callback(int arg1, int arg2, void *common)
{
	gExitRequest = 1;
	return 0;
}

//==============================================================
// Power callback
//--------------------------------------------------------------
// d֘ÃCxg

int power_callback(int unknown, int pwrflags, void *common)
{
	if (pwrflags & PSP_POWER_CB_RESUME_COMPLETE){				// W[
		gResumeFlag = 1;
	}

    sceDisplayWaitVblankStart();

	return 0;
}

//==============================================================
// Callback thread
//--------------------------------------------------------------

int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);
    cbid = sceKernelCreateCallback("Power Callback", power_callback, NULL);
    scePowerRegisterCallback(0, cbid);

	sceKernelSleepThreadCB();

	return 0;
}

//==============================================================
// Sets up the callback thread and returns its thread id
//--------------------------------------------------------------

int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, THREAD_ATTR_USER, 0);
	if(thid >= 0){
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}
